﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AppointmentsUi.Views
{
    public partial class PhoneTypesList : Form
    {
        public PhoneTypesList()
        {
            InitializeComponent();

            var phoneTypes = AppointmentsLib.Models.PhoneType.GetPhoneTypes();

            for (int i = 0; i < phoneTypes.Count(); i++)
            {
                var phoneType = phoneTypes.ElementAt(i);

                var labelPhoneTypeId = new Label() { Text = phoneType.PhoneTypeId.ToString(), AutoSize = true, TextAlign = ContentAlignment.MiddleCenter };
                var textboxPhoneTypeName = new TextBox() { Text = phoneType.Label, AutoSize = true };
                var buttonApplyChanges = new Button() { Text = "Apply" };
                var buttonDelete = new Button() { Text = "Delete" };

                buttonApplyChanges.Click += new EventHandler(delegate (object sender, EventArgs e) {
                    phoneType.Save();
                    Program.mainForm.EmbedForm<PhoneTypesList>();
                });
                buttonDelete.Click += new EventHandler(delegate (object sender, EventArgs e) {
                    var res = MessageBox.Show($"Are you sure to delete the phone type\n{phoneType.Label}\n?", "Delete phone type?", MessageBoxButtons.YesNo);
                    if (res == DialogResult.Yes)
                    {
                        phoneType.Delete();
                        Program.mainForm.EmbedForm<PhoneTypesList>();
                    }
                });
                textboxPhoneTypeName.TextChanged += new EventHandler(delegate (object sender, EventArgs e) {
                    phoneType.Label = textboxPhoneTypeName.Text;
                });

                tableLayoutPanelPhoneTypes.Controls.Add(labelPhoneTypeId, 0, 1 + i);
                tableLayoutPanelPhoneTypes.Controls.Add(textboxPhoneTypeName, 1, 1 + i);
                tableLayoutPanelPhoneTypes.Controls.Add(buttonApplyChanges, 2, 1 + i);
                tableLayoutPanelPhoneTypes.Controls.Add(buttonDelete, 3, 1 + i);
            }
        }

        internal void addPhoneType()
        {
            AppointmentsLib.Models.PhoneType.Create("New phone type");
            Program.mainForm.EmbedForm<PhoneTypesList>();
        }

        private void buttonAddNewPhoneTypes_Click(object sender, EventArgs e)
        {
            addPhoneType();
        }
    }
}
